package cn.estsh.i3plus.pojo.wms.sqlpack;

import cn.estsh.i3plus.pojo.base.tool.HqlPack;
import cn.estsh.i3plus.pojo.wms.bean.*;

/**
 * @Description : 仓库管理对象封装
 * @Reference :
 * @Author : silliter.yuan
 * @CreateDate : 2018-10-31 10:45
 * @Modify:
 **/
public class WmsHqlPack {

    /**
     * PO订单主表信息 分页查询
     *
     * @param wmsPOMaster
     * @return
     */
    public static String packHqlWmsPOMaster(WmsPOMaster wmsPOMaster) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getStringLikerPack(wmsPOMaster.getOrderNo(), "orderNo", result);
        HqlPack.getStringLikerPack(wmsPOMaster.getType(), "type", result);
        HqlPack.getNumEqualPack(wmsPOMaster.getStatus(), "status", result);
        HqlPack.getStringLikerPack(wmsPOMaster.getVendorNo(), "vendorNo", result);
        HqlPack.getStringLikerPack(wmsPOMaster.getSrc(), "src", result);
        HqlPack.getNumEqualPack(wmsPOMaster.getIsValid(), "isValid", result);

        return result.toString();
    }

    /**
     * 物流路线明细查询条件封装
     *
     * @param wmsRoutingDetail
     * @return
     */
    public static String packHqlWmsRoutingDetail(WmsRoutingDetail wmsRoutingDetail) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(wmsRoutingDetail.getRoutingCode(), "routingCode", result);
        HqlPack.getStringLikerPack(wmsRoutingDetail.getOpStep(), "opStep", result);
        HqlPack.getNumEqualPack(wmsRoutingDetail.getOkSeq(), "okSeq", result);
        HqlPack.getNumEqualPack(wmsRoutingDetail.getNgSeq(), "ngSeq", result);
        HqlPack.getNumEqualPack(wmsRoutingDetail.getSeq(), "seq", result);
        HqlPack.getNumEqualPack(wmsRoutingDetail.getParentSeq(), "parentSeq", result);
        HqlPack.timeBuilder(wmsRoutingDetail.getCreateDateTimeStart(), wmsRoutingDetail.getCreateDateTimeEnd(), "createDatetime", result, true);
        HqlPack.getNumEqualPack(wmsRoutingDetail.getIsValid(), "isValid", result);
        return result.toString();
    }

    /**
     * 物流路线分配查询条件封装
     *
     * @param wmsRoutingAssign
     * @return
     */
    public static String packHqlWmsRoutingAssign(WmsRoutingAssign wmsRoutingAssign) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(wmsRoutingAssign.getWhNo(), "whNo", result);
        HqlPack.getStringLikerPack(wmsRoutingAssign.getZoneNo(), "zoneNo", result);
        HqlPack.getStringLikerPack(wmsRoutingAssign.getLocateNo(), "locateNo", result);
        HqlPack.getStringLikerPack(wmsRoutingAssign.getPartNo(), "partNo", result);
        HqlPack.getStringLikerPack(wmsRoutingAssign.getVendorNo(), "vendorNo", result);
        HqlPack.getStringLikerPack(wmsRoutingAssign.getRoutingCode(), "routingCode", result);
        HqlPack.timeBuilder(wmsRoutingAssign.getCreateDateTimeStart(), wmsRoutingAssign.getCreateDateTimeEnd(), "createDatetime", result, true);
        return result.toString();
    }

    /**
     * 物流路线主表查询条件封装
     *
     * @param wmsRoutingMaster
     * @return
     */
    public static String packHqlWmsRoutingMaster(WmsRoutingMaster wmsRoutingMaster) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(wmsRoutingMaster.getRoutingCode(), "routingCode", result);
        HqlPack.getStringLikerPack(wmsRoutingMaster.getRoutingName(), "routingName", result);
        HqlPack.getNumEqualPack(wmsRoutingMaster.getSeq(), "seq", result);
        HqlPack.timeBuilder(wmsRoutingMaster.getCreateDateTimeStart(), wmsRoutingMaster.getCreateDateTimeEnd(), "createDatetime", result, true);
        HqlPack.getNumEqualPack(wmsRoutingMaster.getIsValid(), "isValid", result);
        return result.toString();
    }

    /**
     * 物料查询条件封装
     *
     * @param wmsPart
     * @return
     */
    public static String packHqlWmsPart(WmsPart wmsPart) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(wmsPart.getPartNo(), "partNo", result);
        HqlPack.timeBuilder(wmsPart.getCreateDateTimeStart(), wmsPart.getCreateDateTimeEnd(), "createDatetime", result, true);
        HqlPack.getStringLikerPack(wmsPart.getPartSpec(), "partSpec", result);
        HqlPack.getStringLikerPack(wmsPart.getPartType(), "partType", result);
        HqlPack.getStringLikerPack(wmsPart.getAbc(), "abc", result);
        HqlPack.getNumEqualPack(wmsPart.getIqc(), "iqc", result);
        HqlPack.getStringLikerPack(wmsPart.getPartGroup(), "partGroup", result);
        return result.toString();
    }

    /**
     * 抽点比例信息 分页查询
     *
     * @param wmsIbCheckPlan
     * @return
     */
    public static String packHqlWmsIbCheckPlan(WmsIbCheckPlan wmsIbCheckPlan) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getStringLikerPack(wmsIbCheckPlan.getPartNo(), "partNo", result);
        HqlPack.getStringLikerPack(wmsIbCheckPlan.getPartNameRdd(), "partNameRdd", result);
        HqlPack.getNumEqualPack(wmsIbCheckPlan.getIsValid(), "isValid", result);

        return result.toString();
    }

    /**
     * 库位物料信息 分页查询
     *
     * @param wmsLocatePart
     * @return
     */
    public static String packHqlWmsLocatePart(WmsLocatePart wmsLocatePart) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getStringLikerPack(wmsLocatePart.getLocateNo(), "locateNo", result);
        HqlPack.getStringLikerPack(wmsLocatePart.getPartNo(), "partNo", result);
        HqlPack.getStringLikerPack(wmsLocatePart.getPartName(), "partName", result);
        HqlPack.getNumEqualPack(wmsLocatePart.getIsValid(), "isValid", result);

        return result.toString();
    }

    /**
     * 库位信息 分页查询
     *
     * @param wmsLocate
     * @return
     */
    public static String packHqlWmsLocates(WmsLocate wmsLocate) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getStringLikerPack(wmsLocate.getLocateNo(), "locateNo", result);
        HqlPack.getStringLikerPack(wmsLocate.getLocateName(), "locateName", result);
        HqlPack.getStringLikerPack(wmsLocate.getLocateType(), "locateType", result);
        HqlPack.getStringLikerPack(wmsLocate.getWhNo(), "whNo", result);
        HqlPack.getStringLikerPack(wmsLocate.getZoneNo(), "zoneNo", result);
        HqlPack.getNumEqualPack(wmsLocate.getIsValid(), "isValid", result);

        return result.toString();
    }

    /**
     * 工厂仓库模糊分页查询
     *
     * @param wareHouse
     * @return
     */
    public static String packHqlFactoryStore(WareHouse wareHouse) {
        StringBuffer result = new StringBuffer();

        // 部门名称
        HqlPack.getStringLikerPack(wareHouse.getCode(), "code", result);
        // 部门代码
        HqlPack.getStringLikerPack(wareHouse.getName(), "name", result);

        return result.toString();
    }

    public static String packHqlWmsButton(WmsButton wmsButton) {
        StringBuffer result = new StringBuffer();

        // 功能名称（name）
        HqlPack.getStringLikerPack(wmsButton.getName(), "name", result);
        // 前端实现（ui）
        HqlPack.getStringLikerPack(wmsButton.getUi(), "ui", result);
        // URI权限规则（bs）
        HqlPack.getStringLikerPack(wmsButton.getBs(), "bs", result);

        return result.toString();
    }

    /**
     * 元数据信息 分页查询
     *
     * @param wmsObject
     * @return
     */
    public static String packHqlWmsObject(WmsObject wmsObject) {
        StringBuffer result = new StringBuffer();

        // 编码
        HqlPack.getStringLikerPack(wmsObject.getCode(), "code", result);
        // 名称
        HqlPack.getStringEqualPack(wmsObject.getName(), "name", result);
        // 数据主表
        HqlPack.getStringEqualPack(wmsObject.getTableName(), "tableName", result);
        // 自定义业务拦截
        HqlPack.getStringEqualPack(wmsObject.getBizIntercept(), "bizIntercept", result);

        return result.toString();
    }

    /**
     * 元数据字段分页查询
     *
     * @param wmsField
     * @return
     */
    public static String packHqlWmsField(WmsField wmsField) {
        StringBuffer result = new StringBuffer();
        // 编码
        HqlPack.getStringLikerPack(wmsField.getObjectCode(), "objectCode", result);
        HqlPack.getStringLikerPack(wmsField.getTableName(), "tableName", result);
        return result.toString();
    }


    /**
     * 交易类型信息 分页查询
     *
     * @param wmsTransType
     * @return
     */
    public static String packHqlWmsTransType(WmsTransType wmsTransType) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getNumEqualPack(wmsTransType.getIsValid(), "isValid", result);
        HqlPack.getStringLikerPack(wmsTransType.getTransTypeCode(), "transTypeCode", result);
        HqlPack.getStringLikerPack(wmsTransType.getTransTypeName(), "transTypeName", result);

        return result.toString();
    }

    /**
     * 库存交易记录信息 分页查询
     *
     * @param wmsTrans
     * @return
     */
    public static String packHqlWmsTrans(WmsTrans wmsTrans) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getStringEqualPack(wmsTrans.getTransCode(), "transCode", result);
        HqlPack.getStringEqualPack(wmsTrans.getSn(), "sn", result);
        HqlPack.timeBuilder(wmsTrans.getCreateDatetime(), null, "createDatetime", result, true);

        return result.toString();
    }

    /**
     * 仓库分页查询条件
     *
     * @param wareHouse
     * @return
     */
    public static String packHqlWareHouse(WareHouse wareHouse) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(wareHouse.getAddress(), "address", result);
        HqlPack.getStringLikerPack(wareHouse.getCode(), "code", result);
        HqlPack.getStringLikerPack(wareHouse.getName(), "name", result);
        HqlPack.getNumEqualPack(wareHouse.getIsValid(), "isValid", result);
        return result.toString();
    }

    /**
     * 供应商分页查询
     *
     * @param basVendor
     * @return
     */
    public static String packHqlBasVendor(BasVendor basVendor) {
        StringBuffer result = new StringBuffer();

        HqlPack.getStringLikerPack(basVendor.getVendorNo(), "vendorNo", result);
        HqlPack.getStringLikerPack(basVendor.getVendorName(), "vendorName", result);
        HqlPack.getStringLikerPack(basVendor.getVendorOwner(), "vendorOwner", result);
        HqlPack.getStringLikerPack(basVendor.getVendorDesc(), "vendorDesc", result);
        HqlPack.getStringLikerPack(basVendor.getVendorAddr(), "vendorAddr", result);
        HqlPack.getStringLikerPack(basVendor.getVendorEmail(), "vendorEmail", result);
        if (basVendor.getIsAsn() != null) {
            HqlPack.getStringLikerPack(basVendor.getIsAsn().toString(), "isAsn", result);
        }
        HqlPack.getNumEqualPack(basVendor.getIsValid(), "isValid", result);
        return result.toString();
    }

    /**
     * 作业类型分页查询
     *
     * @param wmsOpType
     * @return
     */
    public static String packHqlWmsOpType(WmsOpType wmsOpType) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(wmsOpType.getOpTypeCode(), "opTypeCode", result);
        HqlPack.getStringLikerPack(wmsOpType.getOpTypeName(), "opTypeName", result);
        if(wmsOpType.getSeq()!= null){
            HqlPack.getStringLikerPack(wmsOpType.getSeq().toString(), "seq", result);
        }
        HqlPack.getStringLikerPack(wmsOpType.getProCode(), "proCode", result);
        HqlPack.getNumEqualPack(wmsOpType.getIsValid(), "isValid", result);
        return result.toString();
    }

    /**
     * 仓库唯一性校验查询条件【用于添加和修改】
     *
     * @param wareHouse
     * @return
     */
    public static String packHqlWareHouseUnique(WareHouse wareHouse) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringEqualPack(wareHouse.getName(), "name", result);
        HqlPack.getStringEqualPack(wareHouse.getCode(), "code", result);
        HqlPack.getNumNOEqualPack(wareHouse.getId(), "id", result);
        return result.toString();
    }

    /**
     * 供应商唯一性校验查询条件【用于添加和修改】
     *
     * @param basVendor
     * @return
     */
    public static String packHqlBasVendorUnique(BasVendor basVendor) {
        StringBuffer result = new StringBuffer();
        if (basVendor.getId() != null) {
            HqlPack.getNumNOEqualPack(basVendor.getId(), "id", result);
        }
        HqlPack.getStringEqualPack(basVendor.getVendorNo(), "vendorNo", result);
        HqlPack.getStringEqualPack(basVendor.getVendorName(), "vendorName", result);
        HqlPack.getStringEqualPack(basVendor.getVendorDesc(), "vendorDesc", result);
        return result.toString();
    }

    public static String packHqlWmsOpTypeUnique(WmsOpType wmsOpType) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(wmsOpType.getOpTypeCode(), "opTypeCode", result);
        HqlPack.getStringLikerPack(wmsOpType.getOpTypeName(), "opTypeName", result);
        return result.toString();
    }

    /**
     * 存储区信息 查询条件封装
     *
     * @param wmsZones
     * @return
     */
    public static String packHqlWmsZones(WmsZones wmsZones) {
        StringBuffer result = new StringBuffer();
        //有效性
        HqlPack.getNumEqualPack(wmsZones.getIsValid(), "isValid", result);
        //仓库代码
        HqlPack.getStringLikerPack(wmsZones.getWhNo(), "whNo", result);
        //库存地代码
        HqlPack.getStringLikerPack(wmsZones.getAreaNo(), "areaNo", result);
        //存储区代码
        HqlPack.getStringLikerPack(wmsZones.getZoneNo(), "zoneNo", result);
        return result.toString();
    }

    /**
     * 客户信息 查询条件封装
     *
     * @param basCustomer
     * @return
     */
    public static String packHqlBasCustomer(BasCustomer basCustomer) {
        StringBuffer result = new StringBuffer();
        //有效性
        HqlPack.getNumEqualPack(basCustomer.getIsValid(), "isValid", result);
        //客户编号
        HqlPack.getStringLikerPack(basCustomer.getCustNo(), "custNo", result);
        //聯係人
        HqlPack.getStringLikerPack(basCustomer.getCustOwner(), "custOwner", result);
        //電話號碼
        HqlPack.getStringLikerPack(basCustomer.getCustTel(), "custTel", result);
        return result.toString();
    }

    /**
     * 客户发往地信息 查询条件封装
     *
     * @param wmsShippingFlag
     * @return
     */
    public static String packHqlWmsShippingFlag(WmsShippingFlag wmsShippingFlag) {
        StringBuffer result = new StringBuffer();
        //有效性
        HqlPack.getNumEqualPack(wmsShippingFlag.getIsValid(), "isValid", result);
        //供应商编号
        HqlPack.getStringLikerPack(wmsShippingFlag.getFlagNo(), "flagNo", result);
        //供应商简称
        HqlPack.getStringLikerPack(wmsShippingFlag.getFlagName(), "flagName", result);
        //供应商全称
        HqlPack.getStringLikerPack(wmsShippingFlag.getFlagDesc(), "flagDesc", result);
        return result.toString();
    }

    /**
     * 产品发运信息 查询条件封装
     *
     * @param wmsShopping
     * @return
     */
    public static String packHqlWmsShipping(WmsShopping wmsShopping) {
        StringBuffer result = new StringBuffer();
        //有效性
        HqlPack.getNumEqualPack(wmsShopping.getIsValid(), "isValid", result);
        //发运单号
        HqlPack.getStringLikerPack(wmsShopping.getOrderNo(), "orderNo", result);
        //客户编码
        HqlPack.getStringLikerPack(wmsShopping.getCustNo(), "custNo", result);
        //条码
        HqlPack.getStringLikerPack(wmsShopping.getPartNo(), "partNo", result);
        //发运状态
        HqlPack.getStringEqualPack(wmsShopping.getStatus().toString(), "status", result);
        return result.toString();
    }
}
